using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using XNACS1Lib;

/// Information on Resoruces:
/// 
/// Images: All images download from: Microsoft Office Clipart: http://office.microsoft.com/en-us/images/
///         format of images may have been converted.
/// 
/// Audio Effect: Recrord by Kelvin Sung.
/// 
/// Background audio: BackgroundMusic.mp3
///     Extracted from: Somewhere Sunny (ver 2).mp3
///     Downloaded from: incompetech.com
///     Original Composer: Kevin MacLeod
///     


namespace ClassExample
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class ClassExample : XNACS1Base
    {
        // Variables should be declared here
        // and initialized in "InitializedWorld()"
        XNACS1Circle myBee;

        // count number of times you have clicked
        int clickCount;

        /// <summary>
        /// Initialize the internal state of your game
        /// </summary>
        protected override void InitializeWorld()
        {
            // Default window size is 800x600
            #region Initialize the window and coordinate
            const float kBgAudioLevel = 0.1f;   // Default Audio level
            const int kWindowWidth = 800;       // Default Window Width
            const int kWindowHeight = 600;      // Default Window Height

            PlayBackgroundAudio("BackgroundMusic", kBgAudioLevel);          // Background audio
            SetAppWindowPixelDimension(false, kWindowWidth, kWindowHeight); // Not full screen
            World.SetWorldCoordinate(min: Vector2.Zero, width: kWindowWidth);           // Each pixel is one unit
            #endregion
            
            myBee = new XNACS1Circle(new Vector2(300f, 400f), 50f, "Bee");

            clickCount = 0;
        }

        /// <summary>
        /// Update the internal state of your game
        /// </summary>
        protected override void UpdateWorld()
        {          
            #region Quit: if the back-button ("F1") is pressed
            if (GamePad.ButtonBackClicked())
                Exit();
            #endregion 

            myBee.CenterX += GamePad.ThumbSticks.Right.X;
            myBee.CenterY += GamePad.ThumbSticks.Right.Y;
            
            if (GamePad.ButtonAClicked())
            {
                clickCount = clickCount + 1;
                XNACS1Circle c = new XNACS1Circle(myBee.Center, 10);
                c.Color = new Color(150, 150, 150, 220);
            }

            if (GamePad.ButtonBClicked())
            {
                clickCount = clickCount + 1;
                XNACS1Circle c = new XNACS1Circle(myBee.Center, 5);
                c.CenterX += RandomInt(-40, 40);
                c.CenterY += RandomInt(-40, 40);
            }

            if (clickCount > 5)
                Exit();
          

            EchoToBottomStatus("Bee location" + myBee.Center);           
            EchoToBottomStatus("clickCount=" + clickCount);
        }
    }
}